## $Id: export.py 14181 2016-09-23 05:54:20Z henrik $
##
## Copyright (C) 2014 Uli Fouquet & Henrik Bettermann
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
##
"""Exporters for uniben customer objects and subobjects.
"""
import grok
from waeup.ikoba.customers.export import (
    CustomerExporter, CustomerDocumentExporterBase, ContractExporterBase)
from ikobacustom.uniben.customers.interfaces import (
    IUnibenCustomer, IUnibenCustomerDocument, IUnibenContractProcess)
from ikobacustom.uniben.interfaces import MessageFactory as _

class UnibenCustomerExporter(CustomerExporter):
    """Exporter for Customers.
    """
    iface = IUnibenCustomer
    title = _(u'Uniben Customers')


class UnibenCustomerDocumentExporter(CustomerDocumentExporterBase):
    """Exporter for documents.
    """
    grok.name('unibencustomerdocuments')
    iface = IUnibenCustomerDocument
    title = _(u'Uniben Customer Documents')
    class_name = 'UnibenCustomerDocument'


class UnibenContractExporter(ContractExporterBase):
    """Exporter for Contract instances.
    """
    grok.name('unibencontracts')
    iface = IUnibenContractProcess
    title = _(u'Uniben Customer Contracts')
    class_name = 'UnibenContract'
